/*  quipu/ufn.h:
 *      RFC1484 User Friendly Naming (UFN) services.
 */

/*
 * $Header: /ic/dev/isode/integration/isode/src/h/quipu/RCS/ufn.h,v 10.2 1994/05/20 14:02:12 jmf Rel $
 *
 *
 * $Log: ufn.h,v $
 * Revision 10.2  1994/05/20  14:02:12  jmf
 * 940520A - Add missing comment delimiter (benign).
 *
 * Revision 10.1  1994/03/25  17:29:19  jmf
 * 940224A - DSAP ANSI conversion.
 * Add C++ encapsulation.
 * Convert function declarations to ASNI and add missing prototypes.
 *
 * Revision 10.0  1993/02/18  20:24:22  awy
 * Release IC-R1
 *
 */

/*
 *                                NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#ifndef _QUIPUUFN_
#define _QUIPUUFN_

#include "quipu/util.h"
#include "quipu/name.h"
#include "quipu/entry.h"
#include "quipu/ds_search.h"


#ifdef __cplusplus
extern "C" {
#endif

typedef struct dn_seq * DNS;
#define NULLDNS ((struct dn_seq *) NULL)

typedef struct _envlist {
	DNS	Dns;
	int	Upper;
	int	Lower;
	struct  _envlist * Next;
} * envlist;
#define NULLEL ((envlist) NULL)
envlist	read_envlist P_((void));

extern char ufn_notify;

extern int ufn_flags;
#define	UFN_NULL	0x00
#define	UFN_APPROX	0x01
#define	UFN_WILDHEAD	0x02
#define	UFN_ALL	(UFN_APPROX | UFN_WILDHEAD)

/*  Prototypes (lib/dsap/common/ufn_parse.c) */

/* MJG bez prototypow funkcji - orig w /opt/isode/include/quipu
extern int ufn_init P_((
    void
));

extern int ufn_match P_((
    int c,
    char **v,
    DNS (*interact) (),
    DNS *result,
    envlist el
));
*/

/*  Prototypes (lib/dsap/common/ufn_aet.c)
extern int aet_match P_((
    int c,
    char **v,
    DNS (*interact) (),
    DNS *result,
    envlist el,
    char *context
));
*/

/*  Prototypes (lib/dsap/common/ufn_parse.c)
extern DNS DNS_append P_((
    DNS a,
    DNS b
));

extern int dnSelect P_((
    char *s,
    DNS *dlist,
    DNS (*interact) (  ),
    DNS el
));

extern int ufn_search P_((
    DN base,
    char subtree,
    Filter filt,
    DNS *res,
    char *s,
    DNS (*interact) (),
    DNS el
));
*/
/*  Prototypes (lib/dsap/common/aetufn.c)
extern int set_lookup_ufn P_((
    char flag
));
*/
/*  Prototypes (lib/dsap/common/aetdap.c)
extern int set_lookup_dap P_((
    char flag
));

*/

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _QUIPUUFN_ */
